#include <stdio.h>
#include <stdlib.h>

typedef struct {
    float x, y;
} Vec2f;

Vec2f* vec2f_new()
{
    return malloc( sizeof( Vec2f ) );
}

void vec2f_delete( Vec2f* v2 )
{
    free( v2 );
}

void vec2f_zero( Vec2f* v )
{
    v->x = 0.0f;
    v->y = 0.0f;
}

void vec2f_set( Vec2f* v, float x, float y )
{
    v->x = x;
    v->y = y;
}

void vec2f_print( Vec2f* v )
{
    printf( "( %f, %f )\n", v->x, v->y );
}

void vec2f_add( Vec2f* v, const Vec2f* a, const Vec2f* b  )
{
    v->x = a->x + b->x;
    v->y = a->y + b->y;
}

void vec2f_scale( Vec2f* v, const Vec2f* a, float scale  )
{
    v->x = a->x * scale;
    v->y = a->y * scale;
}

int main()
{
    Vec2f a, b;
    Vec2f* c;

    c = vec2f_new();

    vec2f_zero( &a );
    vec2f_zero( &b );
    vec2f_zero( c );

    vec2f_print( &a );
    vec2f_print( &b );
    vec2f_print( c );

    vec2f_set( c, 1.0f, 2.0f );
    vec2f_print( c );

    vec2f_scale( &a, c, 2.0f );
    vec2f_print( &a );

    vec2f_delete( c );

}
